package com.company.uuidattr.entity;

import io.jmix.core.DeletePolicy;
import io.jmix.core.entity.annotation.JmixGeneratedValue;
import io.jmix.core.entity.annotation.OnDelete;
import io.jmix.core.metamodel.annotation.Composition;
import io.jmix.core.metamodel.annotation.JmixEntity;

import javax.persistence.Column;
import javax.persistence.ConstraintMode;
import javax.persistence.Entity;
import javax.persistence.ForeignKey;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.OneToMany;
import javax.persistence.OrderBy;
import javax.persistence.Table;
import java.util.ArrayList;
import java.util.List;
import java.util.UUID;

@JmixEntity
@Table(name = "LAB01_MY_CONTAINER")
@Entity(name = "lab01_MyContainer")
public class MyContainer {
    @JmixGeneratedValue
    @Column(name = "ID", nullable = false)
    @Id
    private UUID id;

    @Composition
    @OnDelete(DeletePolicy.CASCADE)
    @OneToMany
    @JoinColumn(name = "PARENT_ID", foreignKey = @ForeignKey(value = ConstraintMode.NO_CONSTRAINT))
    private List<MyEntity> children = new ArrayList<>();

    public UUID getId() {return id;}

    public void setId(UUID id) {this.id = id;}

    public List<MyEntity> getChildren() {
        return children;
    }

    public void setChildren(List<MyEntity> children) {
        this.children = children;
    }
}